
 ************** Generates graphs and tables with descriptive statistics ***********

  program define descriptives

 ************ Push factor maps
 
 	local silent `1'
	****  CODEBOOK FOR SILENT:
	*   1 -> Nice stata output display
	*   0 -> Display everything 

  ******  Local variables to run the stuff quietly or noisily	
  
	if `silent'==1 {
		local sil "qui"
		local noi " "
	}
	else {
		local sil " "
		local noi "qui"
	}

  ******* Program starts

	di " "
	di "   Generate tables and figures of descriptive statistics", as text
	di "---------------------------------------------------------------------------"
	
  
	di "   Maps", as text _continue
	`sil' maps
	di ". . .", as text
 
	di "   Anecdotal evidence", as text _continue
	`sil' anecdotal
	di ". . .", as text
 
	di "   Correlations U.S.", as text _continue
 	`sil' usbilateral "`instr'" "`stats'`usbilateral'" "`push'"
	di ". . .", as text

	di "   Generate tables . . .", as text
	cap log off Main_log
	
	tables_ds

	cap log on Main_log

  end
