
 *----------------- Generates dummies for first stage regressions -----------------


  program define geninteract
  local regional `1'
  
  ************* Interact instruments with cells 
  
	local lst "war regime disasters_affected lny wardummy deaths abspol" 
	local lst "`lst' democracy autocracy dens rer emprate dlny disasters" 
	local lst "`lst' disasters_damage disasters_killed drought_affected_pop" 
	local lst "`lst' equake_affected_p flood_affected_pop storm_affected_pop"

	local term "w r na y wd k ab d a pd re em dy n nd nk da ea fa sa"  
	
	xi, prefix("mdi_") i.cell*ldist
	forvalues i=1/3 {
		forvalues j=1/5 {
			if `i'==1 & `j'==1 {
			}
			else {
				rename mdi_celXldis_`i'`j' mdi_`i'`j'
			}
		}
	}

	foreach l of local lst {
		gettoken t term: term
		xi, prefix("d`t'_") i.cell*ldist_`l'
		xi, prefix("m`t'_") i.cell*`l'
		forvalues i=1/3 {
			forvalues j=1/5 {
				if `i'==1 & `j'==1 {
				}
				else {
					local dist=substr("`l'",1,min(4,length("`l'")))
					rename d`t'_celXldis_`i'`j' d`t'_`i'`j'
					rename m`t'_celX`dist'_`i'`j' m`t'_`i'`j'
				}
			}
		}
		if `regional'==0 {
			xi, prefix("w`t'_") i.cell*aw_ldist_`l'
			xi, prefix("p`t'_") i.cell*pwt_dist_`l'
			xi, prefix("s`t'_") i.cell*csl_`l'
			xi, prefix("l`t'_") i.cell*cle_`l'
			forvalues i=1/3 {
				forvalues j=1/5 {
					if `i'==1 & `j'==1 {
					}
					else {
						rename w`t'_celXaw_l_`i'`j' w`t'_`i'`j'
						rename p`t'_celXpwt__`i'`j' p`t'_`i'`j'
						rename s`t'_celXcsl__`i'`j' s`t'_`i'`j'
						rename l`t'_celXcle__`i'`j' l`t'_`i'`j'
					}
				}
			}
		}
	} 
	drop *_cell_*

		
  end


  
