  
 *------------------  Do first stage regression and save results   ----------------

  program define regsave
	local stage `1'
	local instr `2'

	reg $depvar $varlist $addvars $fe $weight $cond, r

   *=========================================================

	if `stage'==1 {

		cap gen shat=.
		drop shat
		predict double shat, xb
	}

   *=========================================================

	if `stage'==1 {

		local term "w r na y"
		matrix bvec=J(14,1,.)
		matrix sevec=J(14,1,.)
		
		foreach t of local term {
			local i=1
			foreach ij in 12 13 14 15 21 22 23 24 25 31 32 33 34 35 {
				cap matrix bvec[ `i',1]=_b[d`t'_`ij']
				cap matrix sevec[`i',1]=_se[d`t'_`ij']
				local ++i
			}
		}
	}

   *=========================================================

	else if `stage'==2 {

		if `instr'==0 {
			matrix bvec=_b[$sharevar]
			matrix sevec=_se[$sharevar]			
		}
		else {
		
			matrix bvec=_b[shat]

			cap gen err=.
			drop err
			predict double err, residuals
			replace err = err -bvec[1,1]*($sharevar - shat)
			
			local wt=subinstr("$weight","pw","aw",.)
			matrix accum Dz = shat $addvars $fe `wt' $cond
			matrix Dz = syminv(Dz)*r(N)
			qui avar err (shat $addvars $fe) `wt' $cond
			matrix S=r(S)
			matrix Vhat= Dz*S*Dz/e(df_r)

			matrix sevec=sqrt(Vhat[1,1])
		}
	}
  end
    
