
 *----------- Select specific global variables for the regression command ---------


  program define selectlocal
	local stage `1'
	local instr `2'
	local fespec `3'
	local spec `4'
	local count `5'

	global fe "kt_* it_* jt_* ik_* jk_*"
	
	if `fespec'>=2 {
		global fe "$fe ij_*"
	}
	if `fespec'>=3 {
		global fe "$fe ijk_*"
	}
	if `fespec'>=4 {
		global fe "$fe jkt_*"
	}
	if `fespec'>=5 {
		global fe "$fe ikt_*"
	}
	if `fespec'>=6 {
		global fe "$fe ijt_*"
	}
	
	
   *=========================================================

	global addvars " "
	
   *=========================================================

	global cond " "
	if `stage'==2 {
		global cond "if cntry==840 | cntry==124 | cntry>12400"
		if `count'==2 {
			global cond "if cntry==840"
		}
	}
	
   *=========================================================

	global weight "[pw=wt]"
	if `spec'==4 {
		global weight " "
	}
	
   *=========================================================
	
	global sharevar share_all
	if `spec'==2 {
		global sharevar share
	}

   *=========================================================

	if `stage'==1 {
		global depvar $sharevar
	}
	if `stage'==2 {
		global depvar lnmw
		if `spec'==3 {
			global depvar lnw
		}
	}
	
   *=========================================================
	
	if `stage'==1 {
		if `instr'==1 {
			global varlist dw_*	
		}
		else if `instr'==2 {
			global varlist dr_*
		}
		else if `instr'==3 {
			global varlist dna_*
		}
		else if `instr'==4 {
			global varlist dy_*
		}
		else {
			local dist=substr("`instr'",1,1)
			local push=substr("`instr'",2,.)
			if `push'==1 {
				local p="w"
			}
			else if `push'==2 {
				local p="wd"
			}
			else if `push'==3 {
				local p="k"
			}
			else if `push'==4 {
				local p="r"
			}
			else if `push'==5 {
				local p="ab"
			}
			else if `push'==6 {
				local p="d"
			}
			else if `push'==7 {
				local p="a"
			}
			else if `push'==8 {
				local p="na"
			}
			else if `push'==9 {
				local p="n"
			}
			else if `push'==10 {
				local p="nd"
			}
			else if `push'==11 {
				local p="nk"
			}
			else if `push'==12 {
				local p="da"
			}
			else if `push'==13 {
				local p="ea"
			}
			else if `push'==14 {
				local p="fa"
			}
			else if `push'==15 {
				local p="sa"
			}
			else if `push'==16 {
				local p="y"
			}
			else if `push'==17 {
				local p="pd"
			}
			else if `push'==18 {
				local p="re"
			}
			else if `push'==19 {
				local p="em"
			}
			else if `push'==20 {
				local p="dy"
			}
			
			if `dist'==1 {
				local d="d"
			}
			else if `dist'==2 {
				local d="w"
			}
			else if `dist'==3 {
				local d="p"
			}
			else if `dist'==4 {
				local d="l"
			}
			global varlist `d'`p'_*	
		}
	}

   *=========================================================
	
	if `stage'==2 {
		if `instr'==0 {
			global varlist $sharevar
		}
		else {
			global varlist shat
		}
	}

  end
    
