  
 *---------------  Do tests of relevance and stability of instruments  ------------


  program define tests
	local stage `1'
	local gap `2'
	local olsse `3'

	if `stage'==1 {
	   
		cap gen prederror=.
		drop prederror
		predict double prederror, residuals
				
	   *=========================================================

		cap gen yhat=.
		cap gen erry=.
		cap gen xhat=.
		cap gen errx=.
		cap gen errx_uscan=.
		drop yhat erry xhat errx errx_uscan

		reg $depvar $addvars $fe $weight, r
		predict yhat, xb
		scalar df_real=e(rank)
		gen erry=$depvar-yhat
	 
		reg shat $addvars $fe $weight, r
		predict xhat, xb
		gen errx=shat-xhat
		local dfr_reg=`e(df_r)'-2
		
		local dfr=14
						
	   *=========================================================
		
		mkmat errx erry, matrix(R)
		matrix R2=R'*R
		scalar F_uscan=((R2[1,1]/R2[2,2])/`dfr')/((1-R2[1,1]/R2[2,2])/(e(N)-`dfr'))
		
		matrix testvec=F_uscan
		matrix testvec=testvec\(1-F(`dfr',(e(N)-`dfr'),F_uscan))

		matrix testvec=testvec\(e(N)-`dfr')

		scalar relstat=F_uscan

	   *=========================================================
				
		gen errx_uscan=errx
		replace errx_uscan=0 if cntry!=124 & cntry!=840 & cntry<12400	

		reg erry errx_uscan errx, r noc

		matrix testvec=testvec\_b[errx_uscan]
		matrix testvec=testvec\(_b[errx_uscan]/_se[errx_uscan])
		matrix testvec=testvec\ ///
					   (2*ttail(`dfr_reg',abs(_b[errx_uscan]/_se[errx_uscan])))
		matrix testvec=testvec\(`dfr_reg')
		
		scalar stabpval=2*ttail(`dfr_reg',abs(_b[errx_uscan]/_se[errx_uscan]))
				
	   *=========================================================

	}
	else if `stage'==2 {

		local dfr_reg=`e(df_r)'-2

		cap gen ones=1
		drop ones
		gen ones=1
		local wt=subinstr("$weight","pw","aw",.)
		matrix accum Dx = $sharevar $addvars $fe `wt' $cond
		matrix Dx = syminv(Dx)*r(N)
		qui avar err (shat $addvars $fe ones $sharevar $addvars $fe) `wt' $cond
		matrix S=r(S)
		local end1=rowsof(Dx)
		local begin2=`end1'+1
		local end2=2*`end1'
		matrix Szx=S[1..`end1',`begin2'..`end2']
		matrix cov= Dz*Szx*Dx/e(df_r)
		drop ones
			
		matrix testvec=2*ttail(`dfr_reg' , ///
				abs(`gap'/sqrt(sevec[1,1]^2+`olsse'^2-2*cov[1,1])))
	}
  end
   
